# kdecore Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KProcess Class Reference

Child process invocation, monitoring and control. More...

`#include <kprocess.h>`

Inheritance diagram for KProcess:

[legend]
Collaboration diagram for KProcess:

[legend]
List of all members.

## Public Types

enum | Communication { NoCommunication = 0, Stdin = 1, Stdout = 2, Stderr = 4, AllOutput = 6, All = 7, NoRead }
| Modes in which the communication channel can be opened. More...
enum | RunMode { DontCare, NotifyOnExit, Block }
| Run-modes for a child process. More...

## Signals

void | processExited (KProcess *proc)
| Emitted after the process has terminated when the process was run in the `NotifyOnExit` (==default option to start()) or the Block mode.
void | receivedStdout (KProcess *proc, char *buffer, int buflen)
| Emitted, when output from the child process has been received on stdout.
void | receivedStdout (int fd, int &len)
| Emitted when output from the child process has been received on stdout.
void | receivedStderr (KProcess *proc, char *buffer, int buflen)
| Emitted, when output from the child process has been received on stderr.
void | wroteStdin (KProcess *proc)
| Emitted after all the data that has been specified by a prior call to writeStdin() has actually been written to the child process.

## Public Member Functions

| KProcess ()
| Constructor.
virtual | ~KProcess ()
| Destructor:.
bool | setExecutable (const QString &proc)
| This class or method is obsolete, it is provided for compatibility only.
KProcess & | operator<< (const QString &arg)
| Sets the executable and the command line argument list for this process.
KProcess & | operator<< (const char *arg)
| Similar to previous method, takes a char *, supposed to be in locale 8 bit already.
KProcess & | operator<< (const QCString &arg)
| Similar to previous method, takes a QCString, supposed to be in locale 8 bit already.
KProcess & | operator<< (const QStringList &args)
| Sets the executable and the command line argument list for this process, in a single method call, or add a list of arguments.
void | clearArguments ()
| Clear a command line argument list that has been set by using the "operator<<".
virtual bool | start (RunMode runmode=NotifyOnExit, Communication comm=NoCommunication)
| Starts the process.
virtual bool | kill (int signo=SIGTERM)
| Stop the process (by sending it a signal).
bool | isRunning () const
| Checks whether the process is running.
pid_t | pid () const
| Returns the process id of the process.
pid_t | getPid () const
| Use pid().
void | suspend ()
| Suspend processing of data from stdout of the child process.
void | resume ()
| Resume processing of data from stdout of the child process.
bool | normalExit () const
int | exitStatus () const
| Returns the exit status of the process.
bool | writeStdin (const char *buffer, int buflen)
| Transmit data to the child process's stdin.
bool | closeStdin ()
| This causes the stdin file descriptor of the child process to be closed indicating an "EOF" to the child.
bool | closeStdout ()
| This causes the stdout file descriptor of the child process to be closed.
bool | closeStderr ()
| This causes the stderr file descriptor of the child process to be closed.
const QValueList< QCString > & | args ()
| Lets you see what your arguments are for debugging.
void | setRunPrivileged (bool keepPrivileges)
| Controls whether the started process should drop any setuid/segid privileges or whether it should keep them.
bool | runPrivileged () const
| Returns whether the started process will drop any setuid/segid privileges or whether it will keep them.
void | setEnvironment (const QString &name, const QString &value)
| Modifies the environment of the process to be started.
void | setWorkingDirectory (const QString &dir)
| Changes the current working directory (CWD) of the process to be started.
void | setUseShell (bool useShell, const char *shell=0)
| Specify whether to start the command via a shell or directly.
void | detach ()
| Detaches KProcess from child process.

## Static Public Member Functions

QString | quote (const QString &arg)
| This function can be used to quote an argument string such that the shell processes it properly.

## Protected Slots

void | slotChildOutput (int fdno)
| This slot gets activated when data from the child's stdout arrives.
void | slotChildError (int fdno)
| This slot gets activated when data from the child's stderr arrives.
void | slotSendData (int dummy)
| Called when another bulk of data can be sent to the child's stdin.

## Protected Member Functions

void | setupEnvironment ()
| Sets up the environment according to the data passed via setEnvironment(...).
virtual int | setupCommunication (Communication comm)
| This function is called from "KProcess::start" right before a "fork" takes place.
virtual int | commSetupDoneP ()
| Called right after a (successful) fork on the parent side.
virtual int | commSetupDoneC ()
| Called right after a (successful) fork, but before an "exec" on the child process' side.
virtual void | processHasExited (int state)
| Immediately called after a process has exited.
virtual void | commClose ()
| Should clean up the communication links to the child after it has exited.
int | childOutput (int fdno)
| Called by "slotChildOutput" this function copies data arriving from the child process's stdout to the respective buffer and emits the signal "@ref receivedStderr".
int | childError (int fdno)
| Called by "slotChildOutput" this function copies data arriving from the child process's stdout to the respective buffer and emits the signal "@ref receivedStderr".
virtual void | virtual_hook (int id, void *data)

## Protected Attributes

QValueList< QCString > | arguments
| The list of the process' command line arguments.
RunMode | run_mode
| How to run the process (Block, NotifyOnExit, DontCare).
bool | runs
| true if the process is currently running.
pid_t | pid_
| The PID of the currently running process (see "getPid()").
int | status
| The process' exit status as returned by "waitpid".
bool | keepPrivs
| See setRunPrivileged().
int | out [2]
| the socket descriptors for stdin/stdout/stderr.
int | in [2]
int | err [2]
QSocketNotifier * | innot
| The socket notifiers for the above socket descriptors.
QSocketNotifier * | outnot
QSocketNotifier * | errnot
Communication | communication
| Lists the communication links that are activated for the child process.
const char * | input_data
int | input_sent
int | input_total

## Friends

class | KProcessController
| KProcessController is a friend of KProcess because it has to have access to various data members.

## Detailed Description

Child process invocation, monitoring and control.

General usage and features

This class allows a KDE application to start child processes without having to worry about UN*X signal handling issues and zombie process reaping.

See also:
  KProcIO

Basically, this class distinguishes three different ways of running child processes:

- KProcess::DontCare -- The child process is invoked and both the child process and the parent process continue concurrently.

Starting a DontCare child process means that the application is not interested in any notification to determine whether the child process has already exited or not.

- KProcess::NotifyOnExit -- The child process is invoked and both the child and the parent process run concurrently.

When the child process exits, the KProcess instance corresponding to it emits the Qt signal processExited().

Since this signal is not emitted from within a UN*X signal handler, arbitrary function calls can be made.

Be aware: When the KProcess objects gets destructed, the child process will be killed if it is still running! This means in particular, that you cannot use a KProcess on the stack with KProcess::NotifyOnExit.

- KProcess::Block -- The child process starts and the parent process is suspended until the child process exits. (Really not recommended for programs with a GUI.)

KProcess also provides several functions for determining the exit status and the pid of the child process it represents.

Furthermore it is possible to supply command-line arguments to the process in a clean fashion (no null -- terminated stringlists and such...)

A small usage example:

     *KProcess *proc = new KProcess;

     **proc << "my_executable";
     **proc << "These" << "are" << "the" << "command" << "line" << "args";
     *QApplication::connect(proc, SIGNAL(processExited(KProcess *)),
                          pointer_to_my_object, SLOT(my_objects_slot(KProcess *)));
     *proc->start();
     *

This will start "my_executable" with the commandline arguments "These"...

When the child process exits, the respective Qt signal will be emitted.

Communication with the child process

KProcess supports communication with the child process through stdin/stdout/stderr.

The following functions are provided for getting data from the child process or sending data to the child's stdin (For more information, have a look at the documentation of each function):

- bool writeStdin(char *buffer, int buflen);
- -- Transmit data to the child process's stdin.

- bool closeStdin();
- -- Closes the child process's stdin (which causes it to see an feof(stdin)). Returns false if you try to close stdin for a process that has been started without a communication channel to stdin.

- bool closeStdout();
- -- Closes the child process's stdout. Returns false if you try to close stdout for a process that has been started without a communication channel to stdout.

- bool closeStderr();
- -- Closes the child process's stderr. Returns false if you try to close stderr for a process that has been started without a communication channel to stderr.

QT signals:

- void receivedStdout(KProcess *proc, char *buffer, int buflen);
- void receivedStderr(KProcess *proc, char *buffer, int buflen);
- -- Indicates that new data has arrived from either the child process's stdout or stderr.

- void wroteStdin(KProcess *proc);
- -- Indicates that all data that has been sent to the child process by a prior call to writeStdin() has actually been transmitted to the client .

Author:
  Christian Czezakte e9025461@student.tuwien.ac.at

Definition at line 146 of file kprocess.h.

## Member Enumeration Documentation

enum KProcess::Communication

Modes in which the communication channel can be opened.

If communication for more than one channel is required, the values have to be or'ed together, for example to get communication with stdout as well as with stdin, you would specify `Stdin` | `Stdout`

If `NoRead` is specified in conjunction with `Stdout`, no data is actually read from `Stdout` but only the signal childOutput(int fd) is emitted.

Definition at line 164 of file kprocess.h.

Referenced by closeStdin(), closeStdout(), commClose(), and setupCommunication().

enum KProcess::RunMode

Run-modes for a child process.

Enumeration values:

  DontCare | The application does not receive notifications from the subprocess when it is finished or aborted.
  NotifyOnExit | The application is notified when the subprocess dies.
  Block | The application is suspended until the started process is finished.

Definition at line 171 of file kprocess.h.

## Constructor & Destructor Documentation

KProcess::KProcess | ( |  | ) |

| Constructor. Definition at line 89 of file kprocess.cpp. References KProcessController::addKProcess(), KProcessController, out, and KProcessController::theKProcessController.

KProcess::~KProcess | ( |  | ) | `[virtual]`

Destructor:.

If the process is running when the destructor for this class is called, the child process is killed with a SIGKILL, but only if the run mode is not of type `DontCare`. Processes started as `DontCare` keep running anyway.

Definition at line 159 of file kprocess.cpp.

References closeStderr(), closeStdin(), closeStdout(), DontCare, kill(), KProcessController::removeKProcess(), run_mode, runs, and KProcessController::theKProcessController.

## Member Function Documentation

bool KProcess::setExecutable | ( | const QString & | proc | ) |

This class or method is obsolete, it is provided for compatibility only.

The use of this function is now deprecated. -- Please use the "operator<<" instead of "setExecutable".

Sets the executable to be started with this KProcess object. Returns false if the process is currently running (in that case the executable remains unchanged.)

See also:
  operator<<

Definition at line 195 of file kprocess.cpp.

References arguments, QValueList< QCString >::begin(), QFile::encodeName(), QValueList< QCString >::isEmpty(), QString::isEmpty(), QValueList< QCString >::prepend(), QValueList< QCString >::remove(), and runs.

KProcess & KProcess::operator<< | ( | const QString & | arg | ) |

Sets the executable and the command line argument list for this process.

For example, doing an "ls -l /usr/local/bin" can be achieved by:

      KProcess p;
      ...
      p << "ls" << "-l" << "/usr/local/bin"

Parameters:

  arg | the argument to add

Returns:
  a reference to this KProcess

Definition at line 227 of file kprocess.cpp.

References QValueList< QCString >::append(), arguments, and QFile::encodeName().

Referenced by operator<<().

KProcess & KProcess::operator<< | ( | const char * | arg | ) |

| Similar to previous method, takes a char *, supposed to be in locale 8 bit already. Definition at line 221 of file kprocess.cpp. References QValueList< QCString >::append(), and arguments.

KProcess & KProcess::operator<< | ( | const QCString & | arg | ) |

Similar to previous method, takes a QCString, supposed to be in locale 8 bit already.

Parameters:

  arg | the argument to add

Returns:
  a reference to this KProcess

Definition at line 216 of file kprocess.cpp.

References operator<<().

KProcess & KProcess::operator<< | ( | const QStringList & | args | ) |

Sets the executable and the command line argument list for this process, in a single method call, or add a list of arguments.

Parameters:

  arg | the arguments to add

Returns:
  a reference to this KProcess

Definition at line 208 of file kprocess.cpp.

References QValueList< QCString >::append(), arguments, and QFile::encodeName().

void KProcess::clearArguments | ( |  | ) |

| Clear a command line argument list that has been set by using the "operator<<". Definition at line 233 of file kprocess.cpp. References arguments, and QValueList< QCString >::clear(). Referenced by KProcIO::resetAll().

bool KProcess::start | ( | RunMode | runmode = NotifyOnExit,
|  | Communication | comm = NoCommunication
| ) | `[virtual]`

Starts the process.

For a detailed description of the various run modes and communication semantics, have a look at the general description of the KProcess class.

The following problems could cause this function to return false:

- The process is already running.
- The command line argument list is empty.
- The starting of the process failed (could not fork).
- The executable was not found.

Parameters:

  runmode | The Run-mode for the process.
  comm | Specifies which communication links should be established to the child process (stdin/stdout/stderr). By default, no communication takes place and the respective communication signals will never get emitted.

Returns:
  true on success, false on error (see above for error conditions)

Reimplemented in KShellProcess.

Definition at line 238 of file kprocess.cpp.

References arguments, Block, KStdAction::close(), commClose(), commSetupDoneC(), commSetupDoneP(), QValueList< QCString >::count(), DontCare, QApplication::flushX(), pid_, processExited(), run_mode, runPrivileged(), runs, setupCommunication(), setupEnvironment(), status, and KProcessController::theKProcessController.

Referenced by KProcIO::start(), and KShellProcess::start().

bool KProcess::kill | ( | int | signo = SIGTERM | ) | `[virtual]`

Stop the process (by sending it a signal).

Parameters:

  signo | The signal to send. The default is SIGTERM.

Returns:
  true if the signal was delivered successfully.

Definition at line 406 of file kprocess.cpp.

References pid_.

Referenced by KProcIO::resetAll(), and ~KProcess().

bool KProcess::isRunning | ( |  | ) | const

Checks whether the process is running.

Returns:
  true if the process is (still) considered to be running

Definition at line 418 of file kprocess.cpp.

References runs.

Referenced by KProcIO::resetAll().

pid_t KProcess::pid | ( |  | ) | const

Returns the process id of the process.

If it is called after the process has exited, it returns the process id of the last child process that was created by this instance of KProcess.

Calling it before any child process has been started by this KProcess instance causes pid() to return 0.

Returns:
  the pid of the process or 0 if no process has been started yet.

Definition at line 425 of file kprocess.cpp.

References pid_.

Referenced by getPid().

pid_t KProcess::getPid | ( |  | ) | const`[inline]`

| Use pid(). This class or method is obsolete, it is provided for compatibility only. Definition at line 312 of file kprocess.h. References pid().

void KProcess::suspend | ( |  | ) |

| Suspend processing of data from stdout of the child process. Definition at line 471 of file kprocess.cpp. References communication, and QSocketNotifier::setEnabled(). Referenced by commSetupDoneP().

void KProcess::resume | ( |  | ) |

| Resume processing of data from stdout of the child process. Definition at line 477 of file kprocess.cpp. References communication, and QSocketNotifier::setEnabled().

bool KProcess::normalExit | ( |  | ) | const

Returns:
  true if the process has already finished and has exited "voluntarily", ie: it has not been killed by a signal.

Note that you should check KProcess::exitStatus() to determine whether the process completed its task successful or not.

Definition at line 432 of file kprocess.cpp.

References pid_, runs, and status.

int KProcess::exitStatus | ( |  | ) | const

Returns the exit status of the process.

Please use KProcess::normalExit() to check whether the process has exited cleanly (i.e., KProcess::normalExit() returns true) before calling this function because if the process did not exit normally, it does not have a valid exit status.

Returns:
  the exit status of the process

Definition at line 440 of file kprocess.cpp.

References status.

bool KProcess::writeStdin | ( | const char * | buffer,
|  | int | buflen
| ) |

Transmit data to the child process's stdin.

KProcess::writeStdin may return false in the following cases:

- The process is not currently running.

- Communication to stdin has not been requested in the start() call.

- Transmission of data to the child process by a previous call to writeStdin() is still in progress.

Please note that the data is sent to the client asynchronously, so when this function returns, the data might not have been processed by the child process.

If all the data has been sent to the client, the signal wroteStdin() will be emitted.

Please note that you must not free "buffer" or call writeStdin() again until either a wroteStdin() signal indicates that the data has been sent or a processHasExited() signal shows that the child process is no longer alive...

Parameters:

  buffer | the buffer to write. Do not free or modify it until you got a wroteStdin() or processHasExited() signal

Returns:
  false if an error has occurred

Definition at line 448 of file kprocess.cpp.

References communication, innot, runs, QSocketNotifier::setEnabled(), and slotSendData().

Referenced by KProcIO::writeStdin().

bool KProcess::closeStdin | ( |  | ) |

This causes the stdin file descriptor of the child process to be closed indicating an "EOF" to the child.

Returns:
  false if no communication to the process's stdin had been specified in the call to start().

Definition at line 483 of file kprocess.cpp.

References KStdAction::close(), Communication, communication, and innot.

Referenced by KProcIO::closeWhenDone(), detach(), and ~KProcess().

bool KProcess::closeStdout | ( |  | ) |

This causes the stdout file descriptor of the child process to be closed.

Returns:
  false if no communication to the process's stdout had been specified in the call to start().

Definition at line 498 of file kprocess.cpp.

References KStdAction::close(), Communication, communication, and out.

Referenced by detach(), slotChildOutput(), and ~KProcess().

bool KProcess::closeStderr | ( |  | ) |

This causes the stderr file descriptor of the child process to be closed.

Returns:
  false if no communication to the process's stderr had been specified in the call to start().

Definition at line 513 of file kprocess.cpp.

References KStdAction::close(), and communication.

Referenced by detach(), slotChildError(), and ~KProcess().

const QValueList<QCString>& KProcess::args | ( |  | ) | `[inline]`

Lets you see what your arguments are for debugging.

Returns:
  the list of arguments

Definition at line 406 of file kprocess.h.

References arguments.

void KProcess::setRunPrivileged | ( | bool | keepPrivileges | ) |

Controls whether the started process should drop any setuid/segid privileges or whether it should keep them.

The default is false : drop privileges

Parameters:

  true | to keep the privileges

Definition at line 147 of file kprocess.cpp.

References keepPrivs.

bool KProcess::runPrivileged | ( |  | ) | const

Returns whether the started process will drop any setuid/segid privileges or whether it will keep them.

Returns:
  true if the process runs privileged

Definition at line 153 of file kprocess.cpp.

References keepPrivs.

Referenced by start().

void KProcess::setEnvironment | ( | const QString & | name,
|  | const QString & | value
| ) |

Modifies the environment of the process to be started.

This function must be called before starting the process.

Parameters:

  name | the name of the environment variable
  value | the new value for the environment variable

Definition at line 117 of file kprocess.cpp.

References KStdAction::name().

void KProcess::setWorkingDirectory | ( | const QString & | dir | ) |

Changes the current working directory (CWD) of the process to be started.

This function must be called before starting the process.

Parameters:

  dir | the new directory

Definition at line 125 of file kprocess.cpp.

void KProcess::setUseShell | ( | bool | useShell,
|  | const char * | shell = 0
| ) |

Specify whether to start the command via a shell or directly.

The default is to start the command directly. If `useShell` is true `shell` will be used as shell, or if shell is empty, the standard shell is used. `quote` A flag indicating whether to quote the arguments.

When using a shell, the caller should make sure that all filenames etc. are properly quoted when passed as argument.

See also:
  quote()

Parameters:

  useShell | true if the command should be started via a shell
  shell | the path to the shell that will execute the process, or 0 to use the standard shell

Since:
  3.1

Definition at line 844 of file kprocess.cpp.

Referenced by KShellProcess::KShellProcess().

QString KProcess::quote | ( | const QString & | arg | ) | `[static]`

This function can be used to quote an argument string such that the shell processes it properly.

This is e. g. necessary for user-provided file names which may contain spaces or quotes. It also prevents expansion of wild cards and environment variables.

Parameters:

  arg | the argument to quite

Returns:
  the quoted argument

Since:
  3.1

Reimplemented in KShellProcess.

Definition at line 854 of file kprocess.cpp.

References QString::append(), QString::fromLatin1(), QString::prepend(), and QString::replace().

Referenced by KShellProcess::quote().

void KProcess::detach | ( |  | ) |

Detaches KProcess from child process.

All communication is closed. No exit notification is emitted any more for the child process. Deleting the KProcess will no longer kill the child process. Note that the current process remains the parent process of the child process.

Definition at line 182 of file kprocess.cpp.

References closeStderr(), closeStdin(), closeStdout(), pid_, KProcessController::removeKProcess(), runs, and KProcessController::theKProcessController.

void KProcess::processExited | ( | KProcess * | proc | ) | `[signal]`

Emitted after the process has terminated when the process was run in the `NotifyOnExit` (==default option to start()) or the Block mode.

Parameters:

  proc | a pointer to the process that has exited

Referenced by processHasExited(), and start().

void KProcess::receivedStdout | ( | KProcess * | proc,
|  | char * | buffer,
|  | int | buflen
| ) | `[signal]`

Emitted, when output from the child process has been received on stdout.

To actually get these signals, the respective communication link (stdout/stderr) has to be turned on in start().

Parameters:

  proc | a pointer to the process that has received the output
  buffer | The data received.
  buflen | The number of bytes that are available.

You should copy the information contained in `buffer` to your private data structures before returning from this slot. Example: QString myBuf = QString::fromLatin1(buffer, buflen);

Referenced by childOutput(), KProcIO::resetAll(), and KProcIO::start().

void KProcess::receivedStdout | ( | int | fd,
|  | int & | len
| ) | `[signal]`

Emitted when output from the child process has been received on stdout.

To actually get these signals, the respective communications link (stdout/stderr) has to be turned on in start() and the `NoRead` flag should have been passed.

You will need to explicitly call resume() after your call to start() to begin processing data from the child process's stdout. This is to ensure that this signal is not emitted when no one is connected to it, otherwise this signal will not be emitted.

The data still has to be read from file descriptor `fd`.

Parameters:

  fd | the file descriptor that provides the data
  len | the number of bytes that have been read from fd must be written here

void KProcess::receivedStderr | ( | KProcess * | proc,
|  | char * | buffer,
|  | int | buflen
| ) | `[signal]`

Emitted, when output from the child process has been received on stderr.

To actually get these signals, the respective communication link (stdout/stderr) has to be turned on in start().

You should copy the information contained in `buffer` to your private data structures before returning from this slot.

Parameters:

  proc | a pointer to the process that has received the data
  buffer | The data received.
  buflen | The number of bytes that are available.

Referenced by childError(), KProcIO::resetAll(), and KProcIO::start().

void KProcess::wroteStdin | ( | KProcess * | proc | ) | `[signal]`

Emitted after all the data that has been specified by a prior call to writeStdin() has actually been written to the child process.

Parameters:

  proc | a pointer to the process

Referenced by KProcIO::resetAll(), slotSendData(), and KProcIO::start().

void KProcess::slotChildOutput | ( | int | fdno | ) | `[protected, slot]`

This slot gets activated when data from the child's stdout arrives.

It usually calls "childOutput"

Parameters:

  the | file descriptor for the output

Definition at line 535 of file kprocess.cpp.

References childOutput(), and closeStdout().

Referenced by commSetupDoneP().

void KProcess::slotChildError | ( | int | fdno | ) | `[protected, slot]`

This slot gets activated when data from the child's stderr arrives.

It usually calls "childError"

Parameters:

  the | file descriptor for the output

Definition at line 542 of file kprocess.cpp.

References childError(), and closeStderr().

Referenced by commSetupDoneP().

void KProcess::slotSendData | ( | int | dummy | ) | `[protected, slot]`

Called when another bulk of data can be sent to the child's stdin.

If there is no more data to be sent to stdin currently available, this function must disable the QSocketNotifier "innot".

Parameters:

  dummy | ignore this argument

Definition at line 549 of file kprocess.cpp.

References innot, QSocketNotifier::setEnabled(), and wroteStdin().

Referenced by commSetupDoneP(), and writeStdin().

void KProcess::setupEnvironment | ( |  | ) | `[protected]`

| Sets up the environment according to the data passed via setEnvironment(...). Definition at line 133 of file kprocess.cpp. References QFile::encodeName(). Referenced by start().

int KProcess::setupCommunication | ( | Communication | comm | ) | `[protected, virtual]`

This function is called from "KProcess::start" right before a "fork" takes place.

According to the "comm" parameter this function has to initialize the "in", "out" and "err" data member of KProcess.

This function should return 0 if setting the needed communication channels was successful.

The default implementation is to create UNIX STREAM sockets for the communication, but you could overload this function and establish a TCP/IP communication for network communication, for example.

Definition at line 625 of file kprocess.cpp.

References KStdAction::close(), Communication, communication, and out.

Referenced by start().

int KProcess::commSetupDoneP | ( |  | ) | `[protected, virtual]`

Called right after a (successful) fork on the parent side.

This function will usually do some communications cleanup, like closing the reading end of the "stdin" communication channel.

Furthermore, it must also create the QSocketNotifiers "innot", "outnot" and "errnot" and connect their Qt slots to the respective KProcess member functions.

For a more detailed explanation, it is best to have a look at the default implementation of "setupCommunication" in kprocess.cpp.

Definition at line 664 of file kprocess.cpp.

References Block, KStdAction::close(), communication, QObject::connect(), innot, out, run_mode, QSocketNotifier::setEnabled(), slotChildError(), slotChildOutput(), slotSendData(), and suspend().

Referenced by start().

int KProcess::commSetupDoneC | ( |  | ) | `[protected, virtual]`

| Called right after a (successful) fork, but before an "exec" on the child process' side. It usually just closes the unused communication ends of "in", "out" and "err" (like the writing end of the "in" communication channel. Definition at line 712 of file kprocess.cpp. References KStdAction::close(), communication, KStdAction::open(), and out. Referenced by start().

void KProcess::processHasExited | ( | int | state | ) | `[protected, virtual]`

| Immediately called after a process has exited. This function normally calls commClose to close all open communication channels to this process and emits the "processExited" signal (if the process was not running in the "DontCare" mode). Definition at line 567 of file kprocess.cpp. References commClose(), DontCare, processExited(), run_mode, runs, and status.

void KProcess::commClose | ( |  | ) | `[protected, virtual]`

| Should clean up the communication links to the child after it has exited. Should be called from "processHasExited". Definition at line 755 of file kprocess.cpp. References childError(), childOutput(), KStdAction::close(), Communication, communication, innot, out, and runs. Referenced by processHasExited(), and start().

int KProcess::childOutput | ( | int | fdno | ) | `[protected]`

| Called by "slotChildOutput" this function copies data arriving from the child process's stdout to the respective buffer and emits the signal "@ref receivedStderr". Definition at line 586 of file kprocess.cpp. References communication, and receivedStdout(). Referenced by commClose(), and slotChildOutput().

int KProcess::childError | ( | int | fdno | ) | `[protected]`

| Called by "slotChildOutput" this function copies data arriving from the child process's stdout to the respective buffer and emits the signal "@ref receivedStderr". Definition at line 611 of file kprocess.cpp. References receivedStderr(). Referenced by commClose(), and slotChildError().

## Friends And Related Function Documentation

friend class KProcessController `[friend]`

| KProcessController is a friend of KProcess because it has to have access to various data members. Definition at line 741 of file kprocess.h. Referenced by KProcess().

## Member Data Documentation

QValueList<QCString> KProcess::arguments `[protected]`

| The list of the process' command line arguments. The first entry in this list is the executable itself. Definition at line 593 of file kprocess.h. Referenced by args(), clearArguments(), operator<<(), setExecutable(), and start().

RunMode KProcess::run_mode `[protected]`

| How to run the process (Block, NotifyOnExit, DontCare). You should not modify this data member directly from derived classes. Definition at line 598 of file kprocess.h. Referenced by commSetupDoneP(), processHasExited(), start(), and ~KProcess().

bool KProcess::runs `[protected]`

true if the process is currently running.

You should not modify this data member directly from derived classes. For reading the value of this data member, please use "isRunning()" since "runs" will probably be made private in later versions of KProcess.

Definition at line 606 of file kprocess.h.

Referenced by commClose(), detach(), isRunning(), normalExit(), processHasExited(), setExecutable(), start(), writeStdin(), and ~KProcess().

pid_t KProcess::pid_ `[protected]`

| The PID of the currently running process (see "getPid()"). You should not modify this data member in derived classes. Please use "getPid()" instead of directly accessing this member function since it will probably be made private in later versions of KProcess. Definition at line 615 of file kprocess.h. Referenced by detach(), kill(), normalExit(), pid(), and start().

int KProcess::status `[protected]`

| The process' exit status as returned by "waitpid". You should not modify the value of this data member from derived classes. You should rather use exitStatus than accessing this data member directly since it will probably be made private in further versions of KProcess. Definition at line 624 of file kprocess.h. Referenced by exitStatus(), normalExit(), processHasExited(), and start().

bool KProcess::keepPrivs `[protected]`

| See setRunPrivileged(). Definition at line 630 of file kprocess.h. Referenced by runPrivileged(), and setRunPrivileged().

int KProcess::out[2]`[protected]`

| the socket descriptors for stdin/stdout/stderr. Definition at line 700 of file kprocess.h. Referenced by closeStdout(), commClose(), commSetupDoneC(), commSetupDoneP(), KProcess(), and setupCommunication().

QSocketNotifier* KProcess::innot `[protected]`

| The socket notifiers for the above socket descriptors. Definition at line 707 of file kprocess.h. Referenced by closeStdin(), commClose(), commSetupDoneP(), slotSendData(), and writeStdin().

Communication KProcess::communication `[protected]`

| Lists the communication links that are activated for the child process. Should not be modified from derived classes. Definition at line 715 of file kprocess.h. Referenced by childOutput(), closeStderr(), closeStdin(), closeStdout(), commClose(), commSetupDoneC(), commSetupDoneP(), resume(), setupCommunication(), suspend(), and writeStdin().

The documentation for this class was generated from the following files:

- kprocess.h
- kprocess.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 12:50:36 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001